/*
* @Author: D.Jane
* @Email: jane.odoo.sp@gmail.com
*/
(function(){
    var instance = openerp;
    var core = instance.web;
    var form_widgets = instance.web.form;


    form_widgets.FieldFloat.include({
        init: function (field_manager, node) {
            this._super(field_manager, node);
            this.thousands_sep = core._t.database.parameters.thousands_sep || ',';
            this.decimal_point = core._t.database.parameters.decimal_point || '.';
            this.rep = "[^" + this.decimal_point + "-\\d]";
            this.re = new RegExp(this.rep,"g");
        },
        initialize_content: function () {
            this._super();
            var self = this;
            if (this.widget === "float_time"){
                return;
            }
            var input = this.$el.children('input');
            if (input) {
                input.on('keyup', function (event) {
                    // skip arrow keys
                    if (event.which >= 37 && event.which <= 40) return;
                    // format number
                    $(this).val(function (index, value) {
                        return self.thousands_separate(value);
                    });
                });
            }
        },
        format_value: function (val, def){
            var value = this._super(val, def);
            return this.thousands_separate(value);
        },
        thousands_separate: function (value) {
            if (!value) {
                return value;
            }
            value = value.toString();
            var v1 = value.replace(this.re, "").replace(/\B(?=((\d{3})+(?!\d)))/g, this.thousands_sep);
            var v = v1.split(this.decimal_point);
            var re = new RegExp("\\" + this.thousands_sep, "g");
            if (v.length > 1) {
                v = v[0] + this.decimal_point + v[1].replace(re, '');
            }
            return v;
        }
    });

    form_widgets.FieldMonetary.include({
        format_value: function (val, def) {
            var value = this._super(val, def);
            return this.thousands_separate(value);
        }
    });
})();